# Sid Meier's Civilization 4
# Copyright Firaxis Games 2007
# ArmyEvents
# Orion's Army Mod
# Modular python project to eliminate or reduce merging tasks

from CvPythonExtensions import *
import BugUtil
import BugCore
import CvUtil
import CvScreensInterface
import CvDebugTools
import CvWBPopups
import PyHelpers
import Popup as PyPopup
import CvCameraControls
import CvTopCivs
import sys
import CvWorldBuilderScreen
import CvAdvisorUtils
import CvTechChooser
import Army
import PyHelpers

# for C++ compatibility
false=False
true=True

# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo
PyCity = PyHelpers.PyCity
PyGame = PyHelpers.PyGame

dArmyList = [
		"UNIT_ANCIENT_ARMY",
		"UNIT_CLASSICAL_ARMY",
		"UNIT_MEDIEVAL_ARMY",
		"UNIT_RENAISSANCE_ARMY",
		"UNIT_INDUSTRIAL_ARMY",
		"UNIT_MODERN_ARMY",
		"UNIT_FUTURE_ARMY"
	]

class ArmyEvents:
	def __init__(self, eventMgr):
# ###############################################################################
#		Important!!!!															#
#		Each function added from CvEventManager.py must be initialized here 	#
# ###############################################################################
		self.__LOG_MOVEMENT = 0
		self.__LOG_UNITBUILD = 0
		self.eventMgr = eventMgr
				
		eventMgr.addEventHandler("unitBuilt", self.onUnitBuilt)	
					
		
	def onUnitBuilt(self, argsList):
		'Unit Completed'
		city = argsList[0]
		unit = argsList[1]
		iOwner = city.getOwner()
		player = PyPlayer(iOwner)
	# Army Mod
		pPlayer = gc.getPlayer(iOwner)
		UnitType = unit.getUnitType()
		iMTI = gc.getInfoTypeForString("UNIT_MTI")
								
		if UnitType == iMTI:
			#CyInterface().addImmediateMessage("B", "")
			if not pPlayer.isNone() and not pPlayer.isBarbarian() and not pPlayer.isHuman( ) and pPlayer.isAlive():	
				Army.doMTIPlacementAI(unit)
	
	# End Army Mod

		CvAdvisorUtils.unitBuiltFeats(city, unit)
		
		if (not self.__LOG_UNITBUILD):
			return
		CvUtil.pyPrint('%s was finished by Player %d Civilization %s' 
			%(PyInfo.UnitInfo(unit.getUnitType()).getDescription(), player.getID(), player.getCivilizationName()))				
					
					
	