# # Sid Meier's Civilization 4
# # Copyright Firaxis Games 2007
# # ArmyGameUtils

import CvUtil
from CvPythonExtensions import *
import CvEventInterface
import CvGameUtils
import Popup as PyPopup
import PyHelpers
import GodsOfOld
import Army
import OVPromotionUtils

# for C++ compatibility
false=False
true=True

# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo
PyCity = PyHelpers.PyCity
PyGame = PyHelpers.PyGame

# Army Mod By Orion Veteran
# Modular Python to eliminate Merging 
class ArmyGameUtils:
	
	def AI_chooseProduction(self,argsList):
		pCity = argsList[0]
# Army Mod	
		iOwner = pCity.getOwner( )
		AIpPlayer = gc.getPlayer(iOwner)		
		MTIProdChance = Army.getMTIProductionChance(AIpPlayer)
		iUnitToProduce = gc.getInfoTypeForString("UNIT_MTI")
		iBarracks = gc.getInfoTypeForString("BUILDING_BARRACKS")
						
		if pCity.isHasBuilding(iBarracks):		
			if pCity.canTrain(iUnitToProduce, 0, 0):
				lUnits = PyPlayer(AIpPlayer.getID()).getUnitList()
				for iUnit in range(len(lUnits)):
					# if there are any MTIs, don't Build one
					if AIpPlayer.getUnit(lUnits[iUnit].getID()).getUnitType() == iUnitToProduce:
						#CyInterface().addImmediateMessage("A", "")					
						return False
			
			
				if OVPromotionUtils.doRandumChance(MTIProdChance):
					# Makes the City produce the unit
					pCity.pushOrder(OrderTypes.ORDER_TRAIN, iUnitToProduce, -1, False, False, False, True)
					#CyInterface().addImmediateMessage("Order Successful", "")
					return True
# End Army Mod

		return False
	
	def AI_unitUpdate(self,argsList):
		pUnit = argsList[0]
# Army Mod
		iOwner = pUnit.getOwner()
		AIpPlayer = gc.getPlayer(iOwner)
		pUnitType = pUnit.getUnitType()
		iMTI = gc.getInfoTypeForString("UNIT_MTI")
		iSiegeTowerType = gc.getInfoTypeForString("UNIT_SIEGE_TOWER")

		if AIpPlayer.isAlive() and not AIpPlayer.isHuman() and not AIpPlayer.isBarbarian():		
			# If unit is an MTI
			if pUnitType == iMTI:				
				Army.doMTIPlacementAI(pUnit)
				#CyInterface().addImmediateMessage("Test", "")
				return True
				
			# If unit is a Siege Tower
			elif pUnitType == iSiegeTowerType:
				if AIpPlayer.isAlive() and not AIpPlayer.isHuman() and not AIpPlayer.isBarbarian():	
					# Is the Siege Tower on a plot adjacent to an enemy city
					if Army.isAdjacentCityPlot(pUnit) == True:
						Army.doTowerAssault(pUnit)
						return True	
# End Army Mod

		return False
	
	
	def getWidgetHelp(self, argsList):
		eWidgetType, iData1, iData2, bOption = argsList
		
		if iData1 == 690:
			return CyTranslator().getText("TXT_KEY_BUILD_ARMY_MOUSE_OVER", ())
			
		elif iData1 == 685:
			return CyTranslator().getText("TXT_KEY_SIEGE_TOWER_ATTACK_MOUSE_OVER", ())
		
		return u""
		
# End Army Mod









